<?php

use UnicaenCode\Util;

/**
 * @var $this       \Application\View\Renderer\PhpRenderer
 * @var $controller \Zend\Mvc\Controller\AbstractController
 * @var $container  \Interop\Container\ContainerInterface
 * @var $viewName   string
 * @var $viewFile   string
 */


$sIntrospection = Util::introspection();
$sCodeGenerator = Util::codeGenerator();
$sPrivileges    = Util::getContainer()->get('UnicaenAuth\Service\Privilege');
/* @var $sPrivileges \UnicaenAuth\Service\PrivilegeService */

$privileges = $sPrivileges->getList();

$privilegesConsts = [];
$constMaxLen      = 0;
foreach ($privileges as $privilege) {
    $value = var_export($privilege->getFullCode(), true);
    $const = strtoupper($privilege->getFullCode());
    $const = str_replace(['-', ' '], ['_', '_'], $const);
    if (strlen($const) > $constMaxLen) $constMaxLen = strlen($const);

    if (!defined(\UnicaenAuth\Provider\Privilege\Privileges::class . '::' . $const)) {
        $privilegesConsts[$const] = $value;
    }
}

asort($privilegesConsts);

$data = '';
foreach ($privilegesConsts as $const => $value) {
    if ('' !== $data) $data .= "\n";
    $data .= "    const " . str_pad($const, $constMaxLen) . " = $value;";
}

echo '<h1>Génération de la classe listant les constantes de privilèges</h1>';

$params = [
    'template'     => 'Privileges',
    'privileges'   => $data,
    'filename'     => 'Application/Provider/Privilege/Privileges.php',
    'echoExpanded' => true,
    'write'        => true,
];

$sCodeGenerator->generate($params);


echo '<div class="alert alert-info" role="alert">Le fichier est récupérable dans le dossier ' . $sCodeGenerator->getOutputDir() . '</div>';