<?php

use UnicaenCode\Form\ElementMaker;
use UnicaenCode\Util;

/**
 * @var $this       \Application\View\Renderer\PhpRenderer
 * @var $controller \Zend\Mvc\Controller\AbstractController
 * @var $container  \Interop\Container\ContainerInterface
 * @var $viewName   string
 * @var $viewFile   string
 */

?>
    <h1>Création d'un nouveau contrôleur</h1>
    <h3>Etape 1 : Paramétrage</h3>

<?php

$form = new \Zend\Form\Form();
$form->add(ElementMaker::text(
    'class', 'Nom de classe du contrôleur', 'Application\Controller\ExempleController'
));
$form->add(ElementMaker::text(
    'route', 'Route par laquelle y accéder depuis une URL (en minus-cules ou snake_case)', 'exemple-de-controlleur'
));
$form->add(ElementMaker::checkbox(
    'generateFactory', 'Générer une factory', true
));
$form->add(ElementMaker::submit('generate', 'Générer le contrôleur'));
$form->setData($controller->getRequest()->getPost());

Util::displayForm($form);

if ($controller->getRequest()->isPost() && $form->isValid()) {

    $sCodeGenerator = Util::codeGenerator();

    $params = [
        'generator'        => 'Controller',
        'class'            => $form->get('class')->getValue(),
        'controllerConfig' => [
            'route' => $form->get('route')->getValue(),
        ],
        'echoExpanded'     => true,
        'write'            => true,
    ];
    if ($form->get('generateFactory')->getValue()) {
        $params['factory'] = [];
    }

    ?>

    <h3>Etape 2 : Création du fichier source du contrôleur</h3>
    <?php $sCodeGenerator->generate($params); ?>
    <div class="alert alert-info">Fichiers récupérables dans le dossier <?php echo $sCodeGenerator->getOutputDir() ?></div>

    <h3>Etape 3 : Déclaration dans le fichier de configuration</h3>
    <div class="alert alert-warning">
        Vous devez maintenant déclarer votre contrôleur dans la configuration de votre module.
    </div>

    <?php
}