<?php

use UnicaenCode\Form\ElementMaker;
use UnicaenCode\Util;

/**
 * @var $this       \Application\View\Renderer\PhpRenderer
 * @var $controller \Zend\Mvc\Controller\AbstractController
 * @var $container  \Interop\Container\ContainerInterface
 * @var $viewName   string
 * @var $viewFile   string
 */

?>
    <h1>Création d'une nouvelle entité</h1>
    <h3>Etape 1 : Paramétrage</h3>

<?php

$form = new \Zend\Form\Form();
$form->add(ElementMaker::text(
    'class', 'Classe de l\'entité', 'Application\Entity\Album',
));
$form->add(ElementMaker::checkbox(
    'generateTrait', 'Générer un trait', true
));
$form->add(ElementMaker::checkbox(
    'generateInterface', 'Générer une interface', false
));
$form->add(ElementMaker::checkbox(
    'useGetter', 'Générer des getters dans les traits et les interfaces', true
));
$form->add(ElementMaker::submit('generate', 'Générer l\'entité'));
$form->setData($controller->getRequest()->getPost());

Util::displayForm($form);

if ($controller->getRequest()->isPost() && $form->isValid()) {

    $sCodeGenerator = Util::codeGenerator();

    $params = [
        'generator'    => 'Entity',
        'class'        => $form->get('class')->getValue(),
        'echoExpanded' => true,
        'write'        => true,
    ];
    if ($form->get('generateTrait')->getValue()) {
        $params['awareTrait'] = [
            'useGetter' => $form->get('useGetter')->getValue(),
        ];
    }
    if ($form->get('generateInterface')->getValue()) {
        $params['awareInterface'] = [
            'useGetter' => $form->get('useGetter')->getValue(),
        ];
    }

    ?>

    <h3>Etape 2 : Création du fichier source de l'entité</h3>
    <?php $sCodeGenerator->generate($params); ?>
    <div class="alert alert-info">Fichiers récupérables dans le dossier <?php echo $sCodeGenerator->getOutputDir() ?></div>

    <?php
}