<?php

use UnicaenCode\Form\ElementMaker;
use UnicaenCode\Util;

/**
 * @var $this       \Application\View\Renderer\PhpRenderer
 * @var $controller \Zend\Mvc\Controller\AbstractController
 * @var $container  \Interop\Container\ContainerInterface
 * @var $viewName   string
 * @var $viewFile   string
 */

?>
    <h1>Création d'un nouveau formulaire</h1>
    <h3>Etape 1 : Paramétrage</h3>

<?php

$form = new \Zend\Form\Form();
$form->add(ElementMaker::select(
    'type', 'Type de formulaire (Form ou Fieldset)', ['Form' => 'Form', 'Fieldset' => 'Fieldset'], 'Form'
));
$form->add(ElementMaker::text(
    'class', 'Nom de classe du formulaire', 'Application\Form\MonFormulaireForm'
));
$form->add(ElementMaker::checkbox(
    'useHydrator', 'Implémenter un hydrateur spécifique'
));
$form->add(ElementMaker::checkbox(
    'generateTrait', 'Générer un trait', true
));
$form->add(ElementMaker::checkbox(
    'generateInterface', 'Générer une interface', false
));
$form->add(ElementMaker::checkbox(
    'useGetter', 'Générer des getters dans les traits et les interfaces', true
));
$form->add(ElementMaker::checkbox(
    'generateFactory', 'Générer une factory', true
));
$form->add(ElementMaker::submit('generate', 'Générer le formulaire'));
$form->setData($controller->getRequest()->getPost());

Util::displayForm($form);

if ($controller->getRequest()->isPost() && $form->isValid()) {

    $type  = $form->get('type')->getValue();
    $class = $form->get('class')->getValue();

    $sCodeGenerator = Util::codeGenerator();

    $params = [
        'generator'    => 'Form',
        'type'         => $type,
        'class'        => $class,
        'useHydrator'  => $form->get('useHydrator')->getValue(),
        'echoExpanded' => true,
        'write'        => true,
    ];
    if ($form->get('generateTrait')->getValue()) {
        $params['awareTrait'] = [
            'useGetter' => $form->get('useGetter')->getValue(),
        ];
    }
    if ($form->get('generateInterface')->getValue()) {
        $params['awareInterface'] = [
            'useGetter' => $form->get('useGetter')->getValue(),
        ];
    }
    if ($form->get('generateFactory')->getValue()) {
        $params['factory'] = [];
    }

    ?>

    <h3>Etape 2 : Création du fichier source du formulaire</h3>
    <?php $sCodeGenerator->generate($params); ?>
    <div class="alert alert-info">Fichiers récupérables dans le dossier <?php echo $sCodeGenerator->getOutputDir() ?></div>

    <h3>Etape 3 : Déclaration dans le fichier de configuration</h3>
    <div class="alert alert-warning">
        Vous devez maintenant déclarer votre formulaire dans la configuration de votre module.
    </div>

    <?php
}