<?php

use UnicaenCode\Form\ElementMaker;
use UnicaenCode\Util;

/**
 * @var $this       \Application\View\Renderer\PhpRenderer
 * @var $controller \Zend\Mvc\Controller\AbstractController
 * @var $container  \Interop\Container\ContainerInterface
 * @var $viewName   string
 * @var $viewFile   string
 */

?>
    <h1>Création d'une nouvelle aide de vue</h1>
    <h3>Etape 1 : Paramétrage</h3>

<?php

$form = new \Zend\Form\Form();
$form->add(ElementMaker::text(
    'class', 'Nom de classe de l\'aide de vue', 'Application\View\Helper\ExempleViewHelper'
));
$form->add(ElementMaker::text(
    'name', 'Nom pour le ServiceLocator (en lowerCamelCase)', 'exemple'
));
$form->add(ElementMaker::checkbox(
    'generateFactory', 'Générer une factory', true
));
$form->add(ElementMaker::submit('generate', 'Générer l\'aide de vue'));
$form->setData($controller->getRequest()->getPost());

Util::displayForm($form);

if ($controller->getRequest()->isPost() && $form->isValid()) {

    $sCodeGenerator = Util::codeGenerator();

    $params = [
        'generator'    => 'ViewHelper',
        'class'        => $form->get('class')->getValue(),
        'name'         => $form->get('name')->getValue(),
        'echoExpanded' => true,
        'write'        => true,
    ];
    if ($form->get('generateFactory')->getValue()) {
        $params['factory'] = [];
    }


    ?>

    <h3>Etape 2 : Création du fichier source de l'aide de vue</h3>
    <?php $sCodeGenerator->generate($params); ?>
    <div class="alert alert-info">Le fichier est récupérable dans le
        dossier <?php echo $sCodeGenerator->getOutputDir() ?></div>

    <h3>Etape 3 : Déclaration dans le fichier de configuration</h3>
    <div class="alert alert-warning">
        Vous devez maintenant déclarer votre aide de vue dans la configuration de votre module.
    </div>

    <h3>Etape 4 : Mise à jour de votre phpRenderer</h3>

    <a href="<?php echo $this->url('unicaen-code', ['view' => 'GenerateApplicationPhpRenderer']); ?>">Aller au générateur de
        phpRenderer</a>
    <?php
}